Module Modulo_General

    Public conexion As String = "packet size=4096;integrated security=SSPI;data source=.;persist security info=False;initial catalog=SisCo"
    Public usuario_actual As String ' para cargar el registro del usuario

    Public tipo_usuario As Integer
    Public codigo, cod_cliente, cod_contrato, cod_Obra, cod_Supervisor, cod_estado, cod_plan, cod_val As Integer

    Public Interconectar As Integer = 0
    Public NombreObra As String

    Public Function leerdatos(ByVal slq As String) As SqlClient.SqlDataReader
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand(slq, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim data As SqlClient.SqlDataReader
            data = comand.ExecuteReader(CommandBehavior.SingleRow)
            If data.HasRows Then
                data.Read()
            End If
            Return data
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
        connection.Close()
    End Function
    Public Function mostrar_Obras() As DataTable 'para mostrar Obras
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select * from Obra", connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function Mostrar_Valorizacion() As DataTable 'para mostrar las Valorizaciones en una grilla
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select Codigo_EstEcoFin as N_Valo,Periodo,Monto_Factura as Monto,Comprobante_de_Pago as Comprobante,Factura from EstadoEconomicoFinanciero where Codigo_obra=" & Interconectar, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function obtener_siguiente(ByVal slq As String) As Integer 'para contador codigos
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand(slq, connection)
            Dim data As Object
            data = comand.ExecuteScalar()
            connection.Close()
            Return data + 1
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function actualiza_datos(ByVal slq As String)
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand(slq, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            comand.ExecuteReader()
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
        connection.Close()
    End Function
    Public Function carga_dataset(ByVal slq As String) As DataSet
        Dim ds As New DataSet
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim adapter As New SqlClient.SqlDataAdapter(slq, connection)
            adapter.TableMappings.Add("Table", "datos")
            adapter.Fill(ds)
            Return ds
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function mostrar_Distritos() As DataTable 'para mostrar Distritos
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select * from distrito", connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function mostrar_TipoUsuario() As DataTable 'para mostrar Tipo de Usuario
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select * from Tipo_Usuario", connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function Contador_Codigo(ByVal slq As String) As Object 'para contador codigos
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand(slq, connection)
            Dim data As Object
            data = comand.ExecuteScalar()
            connection.Close()
            Return data
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function Insertardatos(ByVal slq As String) 'para insertar datos
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand(slq, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            comand.ExecuteNonQuery()
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
        connection.Close()
    End Function
    Public Function mostrar_Plan_Trabajo() As DataTable 'para mostrar Plan Trabajo
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select * from Plan_Trabajo where Codigo_obra=" & Interconectar, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function mostrar_Plan_Valor() As DataTable 'para mostrar Plan en Valorizacion
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select Codigo_plan,Meta,Costo from Plan_Trabajo where Codigo_obra=" & Interconectar, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
    Public Function mostrar_Porcentaje_Valor() As DataTable 'para mostrar Porcentaje en Valorizacion
        Dim connection As New SqlClient.SqlConnection(conexion)
        connection.Open()
        Try
            Dim comand As New SqlClient.SqlCommand("select Codigo_Valorizacion as Codigo, Meta, Periodo , Porcentaje, v.Costo as CV, p.Costo as CM from plan_trabajo as p inner join valorizacion_obra as v on p.codigo_plan = v.codigo_plan where Codigo_obra=" & Interconectar, connection)
            Dim adapter As New SqlClient.SqlDataAdapter(comand)
            Dim dt As New DataTable
            adapter.Fill(dt)
            Return dt
        Catch es As SqlClient.SqlException
            MsgBox(es.Message)
        End Try
    End Function
End Module
